<?php
/**
 * @file
 * Administer Mode permissions
 */

/**
 * Menu callback: Mode add/edit form.
 */
function mode_permissions_edit_form($form, &$form_state, $mode) {
  require_once(drupal_get_path('module', 'user') . '/user.admin.inc');

  $form = user_admin_permissions($form, $form_state);

  // Due to the way this form is rendered in theme_user_admin_permissions, we
  // shove the name field to the bottom, but above the submit button.
  $form['submit']['#weight'] = 3;

  drupal_set_title(t('Mode edit: !name', array('!name' => $mode->name)));

  $form['mode'] = array('#type' => 'value', '#value' => $mode);

  // Populate permissions with stored data
  $permissions = mode_data_load($mode->mid, 'permissions');
  foreach ($form['checkboxes'] as $rid => $options) {
    $defaults = isset($permissions[$rid]) ? explode(', ', $permissions[$rid]) : array();
    $form['checkboxes'][$rid]['#default_value'] = $defaults;
  }

  $form['submit']['#value'] = t('Update mode');

  $form['#theme'] = 'user_admin_permissions';

  return $form;
}

/**
 * Process mode edit form submissions.
 */
function mode_permissions_edit_form_submit($form, &$form_state) {
  $form_values = $form_state['values'];
  $mode = $form_state['values']['mode'];
  $permissions = array();

  $result = db_query('SELECT * FROM {role}');
  foreach ($result as $role) {
    if (isset($form_values[$role->rid])) {
      $form_values[$role->rid] = array_filter($form_values[$role->rid]);
      if (count($form_values[$role->rid])) {
        $permissions[$role->rid] = implode(', ', array_keys($form_values[$role->rid]));
      }
    }
  }

  $status = mode_data_save($mode->mid, 'permissions', $permissions);

  $form_state['redirect'] = 'admin/config/development/mode';
}
